diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/helper/wifi-helper.cc ns-3.31/src/wifi/helper/wifi-helper.cc
--- ns-3.30.1/src/wifi/helper/wifi-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/helper/wifi-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -38,6 +38,7 @@
 #include "ns3/vht-configuration.h"
 #include "ns3/he-configuration.h"
 #include "ns3/obss-pd-algorithm.h"
+#include "ns3/wifi-ack-policy-selector.h"
 #include "wifi-helper.h"
 
 namespace ns3 {
@@ -45,7 +46,7 @@
 NS_LOG_COMPONENT_DEFINE ("WifiHelper");
 
 /**
- * ASCII trace Phy transmit sink with context
+ * ASCII trace PHY transmit sink with context
  * \param stream the output stream
  * \param context the context name
  * \param p the packet
@@ -67,7 +68,7 @@
 }
 
 /**
- * ASCII trace Phy transmit sink without context
+ * ASCII trace PHY transmit sink without context
  * \param stream the output stream
  * \param p the packet
  * \param mode the wifi mode
@@ -87,7 +88,7 @@
 }
 
 /**
- * ASCII trace Phy receive sink with context
+ * ASCII trace PHY receive sink with context
  * \param stream the output stream
  * \param context the context name
  * \param p the packet
@@ -109,7 +110,7 @@
 }
 
 /**
- * ASCII trace Phy receive sink without context
+ * ASCII trace PHY receive sink without context
  * \param stream the output stream
  * \param p the packet
  * \param snr the SNR
@@ -577,7 +578,7 @@
   Ptr<NetDevice> nd,
   bool explicitFilename)
 {
-  //All of the ascii enable functions vector through here including the ones
+  //All of the ASCII enable functions vector through here including the ones
   //that are wandering through all of devices on perhaps all of the nodes in
   //the system. We can only deal with devices of type WifiNetDevice.
   Ptr<WifiNetDevice> device = nd->GetObject<WifiNetDevice> ();
@@ -617,7 +618,7 @@
         }
 
       Ptr<OutputStreamWrapper> theStream = asciiTraceHelper.CreateFileStream (filename);
-      //We could go poking through the phy and the state looking for the
+      //We could go poking through the PHY and the state looking for the
       //correct trace source, but we can let Config deal with that with
       //some search cost.  Since this is presumably happening at topology
       //creation time, it doesn't seem much of a price to pay.
@@ -655,6 +656,10 @@
     m_selectQueueCallback (&SelectQueueByDSField)
 {
   SetRemoteStationManager ("ns3::ArfWifiManager");
+  SetAckPolicySelectorForAc (AC_BE, "ns3::ConstantWifiAckPolicySelector");
+  SetAckPolicySelectorForAc (AC_BK, "ns3::ConstantWifiAckPolicySelector");
+  SetAckPolicySelectorForAc (AC_VI, "ns3::ConstantWifiAckPolicySelector");
+  SetAckPolicySelectorForAc (AC_VO, "ns3::ConstantWifiAckPolicySelector");
 }
 
 void
@@ -704,6 +709,29 @@
 }
 
 void
+WifiHelper::SetAckPolicySelectorForAc (AcIndex ac, std::string type,
+                                       std::string n0, const AttributeValue &v0,
+                                       std::string n1, const AttributeValue &v1,
+                                       std::string n2, const AttributeValue &v2,
+                                       std::string n3, const AttributeValue &v3,
+                                       std::string n4, const AttributeValue &v4,
+                                       std::string n5, const AttributeValue &v5,
+                                       std::string n6, const AttributeValue &v6,
+                                       std::string n7, const AttributeValue &v7)
+{
+  m_ackPolicySelector[ac] = ObjectFactory ();
+  m_ackPolicySelector[ac].SetTypeId (type);
+  m_ackPolicySelector[ac].Set (n0, v0);
+  m_ackPolicySelector[ac].Set (n1, v1);
+  m_ackPolicySelector[ac].Set (n2, v2);
+  m_ackPolicySelector[ac].Set (n3, v3);
+  m_ackPolicySelector[ac].Set (n4, v4);
+  m_ackPolicySelector[ac].Set (n5, v5);
+  m_ackPolicySelector[ac].Set (n6, v6);
+  m_ackPolicySelector[ac].Set (n7, v7);
+}
+
+void
 WifiHelper::SetStandard (WifiPhyStandard standard)
 {
   m_standard = standard;
@@ -767,6 +795,7 @@
           BooleanValue qosSupported;
           PointerValue ptr;
           Ptr<WifiMacQueue> wmq;
+          Ptr<WifiAckPolicySelector> ackSelector;
 
           rmac->GetAttributeFailSafe ("QosSupported", qosSupported);
           if (qosSupported.Get ())
@@ -775,18 +804,30 @@
                                                                           UintegerValue (4));
 
               rmac->GetAttributeFailSafe ("BE_Txop", ptr);
+              ackSelector = m_ackPolicySelector[AC_BE].Create<WifiAckPolicySelector> ();
+              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
+              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
               wmq = ptr.Get<QosTxop> ()->GetWifiMacQueue ();
               ndqi->GetTxQueue (0)->ConnectQueueTraces (wmq);
 
               rmac->GetAttributeFailSafe ("BK_Txop", ptr);
+              ackSelector = m_ackPolicySelector[AC_BK].Create<WifiAckPolicySelector> ();
+              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
+              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
               wmq = ptr.Get<QosTxop> ()->GetWifiMacQueue ();
               ndqi->GetTxQueue (1)->ConnectQueueTraces (wmq);
 
               rmac->GetAttributeFailSafe ("VI_Txop", ptr);
+              ackSelector = m_ackPolicySelector[AC_VI].Create<WifiAckPolicySelector> ();
+              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
+              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
               wmq = ptr.Get<QosTxop> ()->GetWifiMacQueue ();
               ndqi->GetTxQueue (2)->ConnectQueueTraces (wmq);
 
               rmac->GetAttributeFailSafe ("VO_Txop", ptr);
+              ackSelector = m_ackPolicySelector[AC_VO].Create<WifiAckPolicySelector> ();
+              ackSelector->SetQosTxop (ptr.Get<QosTxop> ());
+              ptr.Get<QosTxop> ()->SetAckPolicySelector (ackSelector);
               wmq = ptr.Get<QosTxop> ()->GetWifiMacQueue ();
               ndqi->GetTxQueue (3)->ConnectQueueTraces (wmq);
               ndqi->SetSelectQueueCallback (m_selectQueueCallback);
@@ -877,6 +918,8 @@
   LogComponentEnable ("WifiNetDevice", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiPhyStateHelper", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiPhy", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiPpdu", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiPsdu", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiRadioEnergyModel", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiRemoteStationManager", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiSpectrumPhyInterface", LOG_LEVEL_ALL);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/helper/wifi-helper.h ns-3.31/src/wifi/helper/wifi-helper.h
--- ns-3.30.1/src/wifi/helper/wifi-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/helper/wifi-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -25,6 +25,7 @@
 
 #include "ns3/trace-helper.h"
 #include "ns3/wifi-phy.h"
+#include "ns3/qos-utils.h"
 #include "wifi-mac-helper.h"
 #include <functional>
 
@@ -207,7 +208,7 @@
    * \param txVector the TXVECTOR
    * \param aMpdu the A-MPDU information
    *
-   * Handle tx pcap.
+   * Handle TX pcap.
    */
   static void PcapSniffTxEvent (Ptr<PcapFileWrapper> file,
                                 Ptr<const Packet> packet,
@@ -220,9 +221,9 @@
    * \param channelFreqMhz the channel frequency
    * \param txVector the TXVECTOR
    * \param aMpdu the A-MPDU information
-   * \param signalNoise the rx signal and noise information
+   * \param signalNoise the RX signal and noise information
    *
-   * Handle rx pcap.
+   * Handle RX pcap.
    */
   static void PcapSniffRxEvent (Ptr<PcapFileWrapper> file,
                                 Ptr<const Packet> packet,
@@ -239,14 +240,14 @@
 
 private:
   /**
-   * Get the radiotap header.
+   * Get the Radiotap header.
    *
    * \param packet the packet
    * \param channelFreqMhz the channel frequency
    * \param txVector the TXVECTOR
    * \param aMpdu the A-MPDU information
    *
-   * \returns the radiotap header
+   * \returns the Radiotap header
    */
   static RadiotapHeader GetRadiotapHeader (Ptr<Packet> packet,
                                            uint16_t channelFreqMhz,
@@ -270,13 +271,13 @@
                                    bool explicitFilename);
 
   /**
-   * \brief Enable ascii trace output on the indicated net device.
+   * \brief Enable ASCII trace output on the indicated net device.
    *
    * NetDevice-specific implementation mechanism for hooking the trace and
    * writing to the trace file.
    *
-   * \param stream The output stream object to use when logging ascii traces.
-   * \param prefix Filename prefix to use for ascii trace files.
+   * \param stream The output stream object to use when logging ASCII traces.
+   * \param prefix Filename prefix to use for ASCII trace files.
    * \param nd Net device for which you want to enable tracing.
    * \param explicitFilename Treat the prefix as an explicit filename if true
    */
@@ -375,13 +376,46 @@
                            std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
                            std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue ());
 
+  /**
+   * \param ac the Access Category to attach the ack policy selector to.
+   * \param type the type of ns3::WifiAckPolicySelector to create.
+   * \param n0 the name of the attribute to set
+   * \param v0 the value of the attribute to set
+   * \param n1 the name of the attribute to set
+   * \param v1 the value of the attribute to set
+   * \param n2 the name of the attribute to set
+   * \param v2 the value of the attribute to set
+   * \param n3 the name of the attribute to set
+   * \param v3 the value of the attribute to set
+   * \param n4 the name of the attribute to set
+   * \param v4 the value of the attribute to set
+   * \param n5 the name of the attribute to set
+   * \param v5 the value of the attribute to set
+   * \param n6 the name of the attribute to set
+   * \param v6 the value of the attribute to set
+   * \param n7 the name of the attribute to set
+   * \param v7 the value of the attribute to set
+   *
+   * All the attributes specified in this method should exist
+   * in the requested ack policy selector.
+   */
+  void SetAckPolicySelectorForAc (AcIndex ac, std::string type,
+                                  std::string n0 = "", const AttributeValue &v0 = EmptyAttributeValue (),
+                                  std::string n1 = "", const AttributeValue &v1 = EmptyAttributeValue (),
+                                  std::string n2 = "", const AttributeValue &v2 = EmptyAttributeValue (),
+                                  std::string n3 = "", const AttributeValue &v3 = EmptyAttributeValue (),
+                                  std::string n4 = "", const AttributeValue &v4 = EmptyAttributeValue (),
+                                  std::string n5 = "", const AttributeValue &v5 = EmptyAttributeValue (),
+                                  std::string n6 = "", const AttributeValue &v6 = EmptyAttributeValue (),
+                                  std::string n7 = "", const AttributeValue &v7 = EmptyAttributeValue ());
+
   /// Callback invoked to determine the MAC queue selected for a given packet
   typedef std::function<std::size_t (Ptr<QueueItem>)> SelectQueueCallback;
 
   /**
    * \param f the select queue callback
    *
-   * Set the select queue callback to set on the netdevice queue interface aggregated
+   * Set the select queue callback to set on the NetDevice queue interface aggregated
    * to the WifiNetDevice, in case RegularWifiMac with QoS enabled is used
    */
   void SetSelectQueueCallback (SelectQueueCallback f);
@@ -422,13 +456,13 @@
   virtual NetDeviceContainer Install (const WifiPhyHelper &phy,
                                       const WifiMacHelper &mac, std::string nodeName) const;
   /**
-   * \param standard the phy standard to configure during installation
+   * \param standard the PHY standard to configure during installation
    *
    * This method sets standards-compliant defaults for WifiMac
-   * parameters such as sifs time, slot time, timeout values, etc.,
+   * parameters such as SIFS time, slot time, timeout values, etc.,
    * based on the standard selected.  It results in
    * WifiMac::ConfigureStandard(standard) being called on each
-   * installed mac object.
+   * installed MAC object.
    *
    * The default standard of 802.11a will be applied if SetStandard()
    * is not called.
@@ -454,7 +488,7 @@
 
   /**
   * Assign a fixed random variable stream number to the random variables
-  * used by the Phy and Mac aspects of the Wifi models.  Each device in
+  * used by the PHY and MAC aspects of the Wifi models.  Each device in
   * container c has fixed stream numbers assigned to its random variables.
   * The Wifi channel (e.g. propagation loss model) is excluded.
   * Return the number of streams (possibly zero) that
@@ -470,10 +504,11 @@
 
 
 protected:
-  ObjectFactory m_stationManager; ///< station manager
-  WifiPhyStandard m_standard; ///< wifi standard
+  ObjectFactory m_stationManager;            ///< station manager
+  ObjectFactory m_ackPolicySelector[4];      ///< ack policy selector for all ACs
+  WifiPhyStandard m_standard;                ///< wifi standard
   SelectQueueCallback m_selectQueueCallback; ///< select queue callback
-  ObjectFactory m_obssPdAlgorithm; ///< OBSS PD algorithm
+  ObjectFactory m_obssPdAlgorithm;           ///< OBSS_PD algorithm
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/helper/wifi-mac-helper.h ns-3.31/src/wifi/helper/wifi-mac-helper.h
--- ns-3.30.1/src/wifi/helper/wifi-mac-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/helper/wifi-mac-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -84,7 +84,7 @@
    * \param v10 the value of the attribute to set
    *
    * All the attributes specified in this method should exist
-   * in the requested mac.
+   * in the requested MAC.
    */
   virtual void SetType (std::string type,
                         std::string n0 = "", const AttributeValue &v0 = EmptyAttributeValue (),
@@ -100,6 +100,7 @@
                         std::string n10 = "", const AttributeValue &v10 = EmptyAttributeValue ());
 
   /**
+   * \param device the device within which the MAC object will reside
    * \returns a new MAC object.
    *
    * This allows the ns3::WifiHelper class to create MAC objects from ns3::WifiHelper::Install.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/helper/wifi-radio-energy-model-helper.cc ns-3.31/src/wifi/helper/wifi-radio-energy-model-helper.cc
--- ns-3.30.1/src/wifi/helper/wifi-radio-energy-model-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/helper/wifi-radio-energy-model-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -128,7 +128,7 @@
   source->AppendDeviceEnergyModel (model);
   // set energy source pointer
   model->SetEnergySource (source);
-  // create and register energy model phy listener
+  // create and register energy model PHY listener
   wifiPhy->RegisterListener (model->GetPhyListener ());
   //
   if (m_txCurrentModel.GetTypeId ().GetUid ())
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/helper/wifi-radio-energy-model-helper.h ns-3.31/src/wifi/helper/wifi-radio-energy-model-helper.h
--- ns-3.30.1/src/wifi/helper/wifi-radio-energy-model-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/helper/wifi-radio-energy-model-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -59,16 +59,14 @@
    *
    * Sets the callback to be invoked when energy is depleted.
    */
-  void SetDepletionCallback (
-    WifiRadioEnergyModel::WifiRadioEnergyDepletionCallback callback);
+  void SetDepletionCallback (WifiRadioEnergyModel::WifiRadioEnergyDepletionCallback callback);
 
   /**
    * \param callback Callback function for energy recharged handling.
    *
    * Sets the callback to be invoked when energy is recharged.
    */
-  void SetRechargedCallback (
-    WifiRadioEnergyModel::WifiRadioEnergyRechargedCallback callback);
+  void SetRechargedCallback (WifiRadioEnergyModel::WifiRadioEnergyRechargedCallback callback);
 
   /**
    * \param name the name of the model to set
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/aarfcd-wifi-manager.cc ns-3.31/src/wifi/model/aarfcd-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/aarfcd-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/aarfcd-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -43,7 +43,6 @@
   uint32_t m_failed; ///< failed
   bool m_recovery; ///< recovery
   bool m_justModifyRate; ///< just modify rate
-  uint32_t m_retry; ///< retry
   uint32_t m_successThreshold; ///< success threshold
   uint32_t m_timerTimeout; ///< timer timeout
   uint8_t m_rate; ///< rate
@@ -87,12 +86,12 @@
                    MakeUintegerAccessor (&AarfcdWifiManager::m_minSuccessThreshold),
                    MakeUintegerChecker<uint32_t> ())
     .AddAttribute ("MinRtsWnd",
-                   "Minimum value for Rts window of Aarf-CD",
+                   "Minimum value for RTS window of AARF-CD",
                    UintegerValue (1),
                    MakeUintegerAccessor (&AarfcdWifiManager::m_minRtsWnd),
                    MakeUintegerChecker<uint32_t> ())
     .AddAttribute ("MaxRtsWnd",
-                   "Maximum value for Rts window of Aarf-CD",
+                   "Maximum value for RTS window of AARF-CD",
                    UintegerValue (40),
                    MakeUintegerAccessor (&AarfcdWifiManager::m_maxRtsWnd),
                    MakeUintegerChecker<uint32_t> ())
@@ -150,17 +149,16 @@
   NS_LOG_FUNCTION (this);
   AarfcdWifiRemoteStation *station = new AarfcdWifiRemoteStation ();
 
-  //aarf fields below
+  //AARF fields below
   station->m_successThreshold = m_minSuccessThreshold;
   station->m_timerTimeout = m_minTimerThreshold;
   station->m_rate = 0;
   station->m_success = 0;
   station->m_failed = 0;
   station->m_recovery = false;
-  station->m_retry = 0;
   station->m_timer = 0;
 
-  //aarf-cd specific fields below
+  //AARF-CD specific fields below
   station->m_rtsOn = false;
   station->m_rtsWnd = m_minRtsWnd;
   station->m_rtsCounter = 0;
@@ -180,10 +178,9 @@
 AarfcdWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AarfcdWifiRemoteStation *station = (AarfcdWifiRemoteStation *)st;
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
   station->m_timer++;
   station->m_failed++;
-  station->m_retry++;
   station->m_success = 0;
 
   if (!station->m_rtsOn)
@@ -198,17 +195,17 @@
           ResetRtsWnd (station);
         }
       station->m_rtsCounter = station->m_rtsWnd;
-      if (station->m_retry >= 2)
+      if (station->m_failed >= 2)
         {
           station->m_timer = 0;
         }
     }
   else if (station->m_recovery)
     {
-      NS_ASSERT (station->m_retry >= 1);
+      NS_ASSERT (station->m_failed >= 1);
       station->m_justModifyRate = false;
       station->m_rtsCounter = station->m_rtsWnd;
-      if (station->m_retry == 1)
+      if (station->m_failed == 1)
         {
           //need recovery fallback
           if (m_turnOffRtsAfterRateDecrease)
@@ -229,10 +226,10 @@
     }
   else
     {
-      NS_ASSERT (station->m_retry >= 1);
+      NS_ASSERT (station->m_failed >= 1);
       station->m_justModifyRate = false;
       station->m_rtsCounter = station->m_rtsWnd;
-      if (((station->m_retry - 1) % 2) == 1)
+      if (((station->m_failed - 1) % 2) == 1)
         {
           //need normal fallback
           if (m_turnOffRtsAfterRateDecrease)
@@ -247,7 +244,7 @@
               station->m_rate--;
             }
         }
-      if (station->m_retry >= 2)
+      if (station->m_failed >= 2)
         {
           station->m_timer = 0;
         }
@@ -267,22 +264,21 @@
                                   double ctsSnr, WifiMode ctsMode, double rtsSnr)
 {
   NS_LOG_FUNCTION (this << st << ctsSnr << ctsMode << rtsSnr);
-  AarfcdWifiRemoteStation *station = (AarfcdWifiRemoteStation *) st;
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
   NS_LOG_DEBUG ("station=" << station << " rts ok");
   station->m_rtsCounter--;
 }
 
 void
-AarfcdWifiManager::DoReportDataOk (WifiRemoteStation *st,
-                                   double ackSnr, WifiMode ackMode, double dataSnr)
+AarfcdWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                   double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  AarfcdWifiRemoteStation *station = (AarfcdWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
   station->m_timer++;
   station->m_success++;
   station->m_failed = 0;
   station->m_recovery = false;
-  station->m_retry = 0;
   station->m_justModifyRate = false;
   station->m_haveASuccess = true;
   NS_LOG_DEBUG ("station=" << station << " data ok success=" << station->m_success << ", timer=" << station->m_timer);
@@ -322,11 +318,10 @@
 AarfcdWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AarfcdWifiRemoteStation *station = (AarfcdWifiRemoteStation *) st;
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, station->m_rate);
@@ -342,13 +337,12 @@
 AarfcdWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  /// \todo we could/should implement the Aarf algorithm for
+  /// \todo we could/should implement the AARF algorithm for
   /// RTS only by picking a single rate within the BasicRateSet.
-  AarfcdWifiRemoteStation *station = (AarfcdWifiRemoteStation *) st;
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiTxVector rtsTxVector;
@@ -367,21 +361,15 @@
 
 bool
 AarfcdWifiManager::DoNeedRts (WifiRemoteStation *st,
-                              Ptr<const Packet> packet, bool normally)
+                              uint32_t size, bool normally)
 {
-  NS_LOG_FUNCTION (this << st << packet << normally);
-  AarfcdWifiRemoteStation *station = (AarfcdWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << size << normally);
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
   NS_LOG_INFO ("" << station << " rate=" << station->m_rate << " rts=" << (station->m_rtsOn ? "RTS" : "BASIC") <<
                " rtsCounter=" << station->m_rtsCounter);
   return station->m_rtsOn;
 }
 
-bool
-AarfcdWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 void
 AarfcdWifiManager::CheckRts (AarfcdWifiRemoteStation *station)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/aarfcd-wifi-manager.h ns-3.31/src/wifi/model/aarfcd-wifi-manager.h
--- ns-3.30.1/src/wifi/model/aarfcd-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/aarfcd-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -37,9 +37,9 @@
  * version of ns-3. Federico died before merging this work in ns-3 itself so his code was ported
  * to ns-3 later without his supervision.
  *
- * This RAA does not support HT, VHT nor HE modes and will error
+ * This RAA does not support HT modes and will error
  * exit if the user tries to configure this RAA with a Wi-Fi MAC
- * that has VhtSupported, HtSupported or HeSupported set.
+ * that supports 802.11n or higher.
  */
 class AarfcdWifiManager : public WifiRemoteStationManager
 {
@@ -70,20 +70,19 @@
    * The fundamental reason for this is that there is a backoff between each data
    * transmission, be it an initial transmission or a retransmission.
    *
-   * \param station the station that we failed to send DATA
+   * \param station the station that we failed to send Data
    */
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
   bool DoNeedRts (WifiRemoteStation *station,
-                  Ptr<const Packet> packet, bool normally);
-  bool IsLowLatency (void) const;
+                  uint32_t size, bool normally);
 
   /**
    * Check if the use of RTS for the given station can be turned off.
@@ -116,18 +115,18 @@
    */
   void TurnOnRts (AarfcdWifiRemoteStation *station);
 
-  //aarf fields below
-  uint32_t m_minTimerThreshold; ///< minimum timer threshold
+  //AARF fields below
+  uint32_t m_minTimerThreshold;   ///< minimum timer threshold
   uint32_t m_minSuccessThreshold; ///< minimum success threshold
-  double m_successK; ///< Multiplication factor for the success threshold
+  double m_successK;              ///< Multiplication factor for the success threshold
   uint32_t m_maxSuccessThreshold; ///< maximum success threshold
-  double m_timerK; ///< Multiplication factor for the timer threshold
+  double m_timerK;                ///< Multiplication factor for the timer threshold
 
-  //aarf-cd fields below
-  uint32_t m_minRtsWnd; ///< minimum RTS window
-  uint32_t m_maxRtsWnd; ///< maximum RTS window
+  //AARF-CD fields below
+  uint32_t m_minRtsWnd;               ///< minimum RTS window
+  uint32_t m_maxRtsWnd;               ///< maximum RTS window
   bool m_turnOffRtsAfterRateDecrease; ///< turn off RTS after rate decrease
-  bool m_turnOnRtsAfterRateIncrease; ///< turn on RTS after rate increase
+  bool m_turnOnRtsAfterRateIncrease;  ///< turn on RTS after rate increase
 
   TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/aarf-wifi-manager.cc ns-3.31/src/wifi/model/aarf-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/aarf-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/aarf-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -41,7 +41,6 @@
   uint32_t m_success; ///< success
   uint32_t m_failed; ///< failed
   bool m_recovery; ///< recovery
-  uint32_t m_retry; ///< retry
   uint32_t m_timerTimeout; ///< timer timeout
   uint32_t m_successThreshold; ///< success threshold
   uint8_t m_rate; ///< rate
@@ -130,7 +129,6 @@
   station->m_success = 0;
   station->m_failed = 0;
   station->m_recovery = false;
-  station->m_retry = 0;
   station->m_timer = 0;
 
   return station;
@@ -150,22 +148,21 @@
  * The fundamental reason for this is that there is a backoff between each data
  * transmission, be it an initial transmission or a retransmission.
  *
- * \param st the station that we failed to send DATA
+ * \param st the station that we failed to send Data
  */
 void
 AarfWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AarfWifiRemoteStation *station = (AarfWifiRemoteStation *)st;
+  AarfWifiRemoteStation *station = static_cast<AarfWifiRemoteStation*> (st);
   station->m_timer++;
   station->m_failed++;
-  station->m_retry++;
   station->m_success = 0;
 
   if (station->m_recovery)
     {
-      NS_ASSERT (station->m_retry >= 1);
-      if (station->m_retry == 1)
+      NS_ASSERT (station->m_failed >= 1);
+      if (station->m_failed == 1)
         {
           //need recovery fallback
           station->m_successThreshold = (int)(Min (station->m_successThreshold * m_successK,
@@ -181,8 +178,8 @@
     }
   else
     {
-      NS_ASSERT (station->m_retry >= 1);
-      if (((station->m_retry - 1) % 2) == 1)
+      NS_ASSERT (station->m_failed >= 1);
+      if (((station->m_failed - 1) % 2) == 1)
         {
           //need normal fallback
           station->m_timerTimeout = m_minTimerThreshold;
@@ -192,7 +189,7 @@
               station->m_rate--;
             }
         }
-      if (station->m_retry >= 2)
+      if (station->m_failed >= 2)
         {
           station->m_timer = 0;
         }
@@ -215,16 +212,15 @@
 }
 
 void
-AarfWifiManager::DoReportDataOk (WifiRemoteStation *st,
-                                 double ackSnr, WifiMode ackMode, double dataSnr)
+AarfWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                 double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  AarfWifiRemoteStation *station = (AarfWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  AarfWifiRemoteStation *station = static_cast<AarfWifiRemoteStation*> (st);
   station->m_timer++;
   station->m_success++;
   station->m_failed = 0;
   station->m_recovery = false;
-  station->m_retry = 0;
   NS_LOG_DEBUG ("station=" << station << " data ok success=" << station->m_success << ", timer=" << station->m_timer);
   if ((station->m_success == station->m_successThreshold
        || station->m_timer == station->m_timerTimeout)
@@ -254,11 +250,10 @@
 AarfWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AarfWifiRemoteStation *station = (AarfWifiRemoteStation *) st;
+  AarfWifiRemoteStation *station = static_cast<AarfWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, station->m_rate);
@@ -274,13 +269,12 @@
 AarfWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  /// \todo we could/should implement the Aarf algorithm for
+  /// \todo we could/should implement the AARF algorithm for
   /// RTS only by picking a single rate within the BasicRateSet.
-  AarfWifiRemoteStation *station = (AarfWifiRemoteStation *) st;
+  AarfWifiRemoteStation *station = static_cast<AarfWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiTxVector rtsTxVector;
@@ -297,10 +291,4 @@
   return rtsTxVector;
 }
 
-bool
-AarfWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 } //namespace ns3
